#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h>
//#include <unistd.h>
#include <io.h>
//#include <dos.h>

#include "src/adef.h"
USING_namespace(Ndef)

//
//namespace{
BEGIN_namespace_a
char const *
	err_pr(
		ushort const e
		){

	switch(e){
	case ERR_NO:			return "(no error)";
	
	case ERR_ZPTR:			return "NULL ptr is not allowed as parameter/request";
	case ERR_BOUND:			return "parameter/request out of range";
	case ERR_BADPAR:		return "bad parameter/request";

	case ERR_RES_ZPTR:		return "NULL ptr is not allowed as evaluated result";
	case ERR_RES_BOUND: 	return "evaluated result out of range";
	case ERR_BADRES:		return "bad evaluated result";

	case ERR_NOMEM:			return "no memory";
	case ERR_FILE:			return "file";
	case ERR_NET:			return "network";
	
	case ERR_NOT_IMPL:		return "not implemented";

	//known usr defined
	case ERR_COMXT:			return "COM XT port";

	default:			
		//unknown usr defined
		if( e >= ERR_USRDEF ) return "user local defined code";
		
		//unknown
		return "(unknown)";
	}

}
//}
END_namespace_a

//
void
	REF_namespace(Ndef)
	err(
		ushort const e,
		char const *const msg,
		char const *const who,
		char const *const what
		){

	//
	fprintf(stderr, "error: ");

	if( e < ERR_USRDEF)
		fprintf(stderr, "%u", e );
	else {
		fprintf(stderr, "%s%u", "usr+", (e-ERR_USRDEF) );
	}

	fprintf(stderr, ": %s", err_pr(e) );

	if(msg) fprintf(stderr, ": %s", msg);
	if(who) fprintf(stderr, "\nwho: %s", who);
	if(what)fprintf(stderr, "\nwhat: %s", what);

	fprintf(stderr, "\n");
	exit(e);
}

//
FILE
	*
	REF_namespace(Ndef)
	fdup_pipe(
		FILE *const fw,
		char const *const mode
		){
	int
		dfw, dfr;

	dfw= fileno(fw); if(dfw == -01L)err(ERR_FILE,"fileno fw","fdup_pipe");
	dfr= dup(dfw); if(dfr == -01L)err(ERR_FILE,"dup dfw","fdup_pipe");  
	
	#if 0
	    fdopen 
		  fdopen  dfr (  fopen)
		     dfw   fdopen  fileno(fw)
	  fdopen   dfr (  fopen)
    #endif
	FILE 
		*fr;

	fr= fdopen(dfr, mode); if(!fr)close(dfr);
	
	return fr;
	//drop dfw, dfr values
}
