#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <dos.h>

#include "src/adef.h"
USING_namespace(Ndef)
//
#include "src/dos/dos_irq.h"
USING_namespace(NprA)

//
void
	REF_namespace(NprA)
	Tdos_irq::
	set_irq_handler(
		){

	//
	if(!is_prev_irq_handler)err(ERR_BADPAR, "prev irq_handler was not saved", "set_irq_handler");

	if(!is_init)err(ERR_BADPAR, "irq not defined", "set_irq_handler");
	if(!IRQ_handler_entry)err(ERR_BADPAR, "irq_handler entry point not defined", "set_irq_handler");

	//  IRQ (   com_IRQ_handler)
	{
	ureg16
		ofs16= FP_OFF(IRQ_handler_entry),
		seg16= FP_SEG(IRQ_handler_entry);

	ureg8
		tmp8= irq_num;

	asm{
		push  es
		mov   ax, 0
		mov   es, ax
		
		mov   al, byte ptr tmp8
		shl   ax, 2
		mov   bx, ax
		
		//mov   ax, offset com_IRQ_handler
		mov   ax, word ptr ofs16
		mov   dx, word ptr seg16

		cli
		mov   word ptr es:[bx], ax
		mov   word ptr es:[bx+2], dx
		//for model .small
		//mov   word ptr es:[bx+2], cs
		sti
		pop   es
	}}
}

//
void
	REF_namespace(NprA)
	Tdos_irq::
	save_irq_handler(
		){

	//
	if(is_prev_irq_handler)err(ERR_BADPAR, "prev irq_handler already saved", "save_irq_handler");

	if(!is_init)err(ERR_BADPAR, "irq not defined", "save_irq_handler");

	//   IRQ 
	{
	ureg16
		ofs16,
		seg16;

	ureg8
		tmp8= irq_num;

	asm{
		push  es
		mov   ax, 0
		mov   es, ax
		
		mov   al, byte ptr tmp8
		shl   ax, 2
		mov   bx, ax
		
		les   ax, dword ptr es:[bx]
		mov   word ptr ofs16, ax
		mov   word ptr seg16, es
		pop   es
	}

	prev_irq_handler_ofs= ofs16;
	prev_irq_handler_seg= seg16;
	}

	//
	is_prev_irq_handler= 1;
}

//
void
	REF_namespace(NprA)
	Tdos_irq::
	restore_irq_handler(
		){

	//      IRQ   
	if(!is_prev_irq_handler)return;

	if(!is_init)err(ERR_BADPAR, "irq not defined", "restore_irq_handler");

	//   IRQ 
	{
	ureg16
		ofs16= prev_irq_handler_ofs,
		seg16= prev_irq_handler_seg;
	
	ureg8
		tmp8= irq_num;

	asm{
		push  es
		mov   ax, 0
		mov   es, ax
		
		mov   al, byte ptr tmp8
		shl   ax, 2
		mov   bx, ax
		
		mov   ax, word ptr ofs16
		mov   dx, word ptr seg16

		cli
		mov   word ptr es:[bx], ax
		mov   word ptr es:[bx+2], dx
		sti
		pop   es
	}}

	//
	is_prev_irq_handler= 0;
}
