#ifndef DOS_IRQ_H
#define DOS_IRQ_H
//     IRQ  

//namespace NprA{
BEGIN_namespace(NprA)

//  IRQ
typedef 
	void
		interrupt
		(*t_IRQ_handler_entry)();

///  ( BIOS)  IRQ 
//     CPU
class Tdos_irq{
public:
	//0  irq_num  
	bool
		is_init;

	//IRQ number   
	ureg8
		irq_num;

	//           
	//          irq_num

public:
	//   IRQ     CPU
	//	irq_num           init
	//    save_irq_handler   restore_irq_handler
	// save_irq_handler    init
	//   sti
	void
		save_irq_handler();

	//   IRQ     CPU
	//	irq_num           init
	//	IRQ_handler_entry      
	//   IRQ     (     )
	//    set_irq_handler     save_irq_handler
	// set_irq_handler    init
	//   sti
	void
		set_irq_handler();

	//   IRQ     CPU
	//        
	//   sti
	void
		restore_irq_handler();

	// Tdos_irq     
	//	( irq_num, IRQ_handler_entry)   init
	//	(  ) save_irq_handler()
	//	(  ) set_irq_handler()
	//	(  ) restore_irq_handler()

public:
	//0    IRQ   
	//restore_irq_handler   
	//     prev_  (prev_irq_handler_xxx  ..)
	bool
		is_prev_irq_handler;

	//  IRQ
	ureg16
		prev_irq_handler_ofs,
		prev_irq_handler_seg;
	
	// save_irq_handler  
	//	    BIOS   spurious INT
	//		 restore   

public:
	//     IRQ_handler (    prev_) 
	//   entry        IRQ_handler_body
	// entry   IRQ_handler_body     
	//     main
	// 0          
	t_IRQ_handler_entry
		IRQ_handler_entry;

public:
		~Tdos_irq(){ restore_irq_handler(); }
	
	// Tdos_irq  
		Tdos_irq(
			): 
			is_init(0),
			is_prev_irq_handler(0), 
			IRQ_handler_entry(0) 
			{ 
		//save_irq_handler   ,   irq_num
	}

	// Tdos_irq  ,   entry
		Tdos_irq(
			t_IRQ_handler_entry const entry,
			ctor_explicit
			): 
			is_init(0),
			is_prev_irq_handler(0), 
			IRQ_handler_entry(entry) 
			{ 
		//save_irq_handler   ,   irq_num
	}

	// Tdos_irq  { save_irq_handler(), set_irq_handler() }
		Tdos_irq(
			ureg8 const i_n, 
			t_IRQ_handler_entry const entry,
			ctor_explicit
			): 
			is_init(1),
			irq_num(i_n),
			is_prev_irq_handler(0), 
			IRQ_handler_entry(entry) 
			{ 
		
		//save_irq_handler   ,   irq_num
		save_irq_handler();
		if(entry)set_irq_handler();
	}

private:
	//    
	// Tdos_irq       
		Tdos_irq(Tdos_irq const&);
	Tdos_irq& operator=(Tdos_irq const&);

	//  Tdos_irq  prev_ 
	//   irq_num   set_irq_handler() 
	//       ~Tdos_irq
	//    IRQ  
	//	  exit()   
	//	 restore_irq_handler()   
	//	     atexit  
	//	atexit      Tdos_irq   
};

//namespace NprA
END_namespace(NprA)
#endif
