#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"

#include "src/dos/pra_dos.h"
USING_namespace(NprA)

//
Tdos_uart_conf
	REF_namespace(NprA)
	dos_uart_conf[DOS_COM_PORTS];

char const
	*const
	REF_namespace(NprA)
	pra_conf_ini_fname
		= "pra_dos.ini";

//**********************
static
char
	//  
	buf[40+1];

//
bool
	REF_namespace(NprA)
	read_pra_conf(
		){

	FILE
		*fi= fopen(pra_conf_ini_fname,"rb"); if(!fi)return 0;
	
	unsigned short
		com_idx= 0;

	long
		fpos;

	//   DOS_COM_PORTS    
	for(;;){ 

		fpos= ftell(fi); if( fpos == -1L )err(ERR_FILE,"ftell","dos read_pra_conf");
		if( fscanf(fi, " [ COM%1hu ]", &com_idx) != 1 ){
			
			// 
			if( feof(fi) )return 1;

			//     [COMx]
			if( fseek(fi,fpos,SEEK_SET) )err(ERR_FILE,"fseek","dos read_pra_conf");
			fgets(buf, sizeof(buf), fi);	
			fprintf(stderr,"bad config string (next INI lines ignored): %s\n",buf); 
			return 0;
		}

		//  com_idx
		--com_idx;
		if( com_idx >= DOS_COM_PORTS ){
			fprintf(stderr,"bad config com_num (next INI lines ignored): %hu\n", (com_idx+1)); 
			return 0;
		}

		//   DOS
		for(;;){

			//      
			fpos= ftell(fi); if( fpos == -1L )err(ERR_FILE,"ftell","dos read_pra_conf");
			
			//  "irq_num = val;"
			unsigned short
				irq_num= Tdos_uart::IRQ_DEF;

			if( fscanf(fi, " irq_num = %hu ;", &irq_num) == 1 ){
				
				dos_uart_conf[com_idx].irq_num = irq_num;
				//  
				continue;
			}

			//     DOS
			//        
			if( fseek(fi,fpos,SEEK_SET) )err(ERR_FILE,"fseek","dos read_pra_conf");
			break;
		}

		//   pra_conf {...}  COM<com_num>
		if( !dug[com_idx].pra_conf.read(fi) ){
			
			fprintf(stderr,"there were errors reading COM%hu block {..} (next INI lines ignored)\n", (com_idx+1)); 
			return 0;
		}
	}
}
