#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <conio.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"

#include "src/dos/pra_dos.h"
USING_namespace(NprA)

//
void
	REF_namespace(NprA)
	Tdos_com_port::
	reset(
		){
	
	is_tx_DLE= 0;
	dug[dos_com_idx].dos_uart.reset();
}

//
t_prot_ch
	REF_namespace(NprA)
	Tdos_com_port::
	tx_DLE(
		t_fi_ch const fi_ch
		){

	//    
	//    DLE 
	switch(fi_ch){
		case PR_DLE:	is_tx_DLE= 1; tx_DLE_data= PR_DLE_DLE; return PR_DLE;
		case PR_SYN: 	is_tx_DLE= 1; tx_DLE_data= PR_DLE_SYN; return PR_DLE;
		default:		is_tx_DLE= 0; return fi_ch;
	}
}

//
bool
	REF_namespace(NprA)
	Tdos_com_port::
	tx_ch( 
		t_prot_ch const prot_ch
		){

	//   tx_line
	timer_tx_line[dos_com_idx].start();

	//    UART   tx_line
	//    IRQ 
	for(;;){

		//    
		//      tx   UART
		//.. tx   UART    
		//  tx  ,        
		//      tx   UART
		//..      tx      hlt
		//     hlt    
		
		//   uart     tx
		//tx_ch  1      uart
		//tx_ch   cli    
		if( dug[dos_com_idx].dos_uart.tx_ch(prot_ch, 0) ){
			asm sti; 
			timer_tx_line[dos_com_idx].stop();
			return 1; 
		}

		//     
		//     tx_line
		if( timer_tx_line[dos_com_idx].is_timeout ){ 
			asm sti; 
			//     uart
			//   tx_line
			// !is_drop_TX_LINE   
			++dug[dos_com_idx].pra_stat.tx_err_line; 
			if(!dug[dos_com_idx].pra_conf.is_drop_TX_LINE) err(ERR_COMXT, "PE_TX_LINE"); 
			return 0; 
		}

		//        rx  timeout
		// cli  "sti; hlt; cli"      
		//  IRQ   (   hlt)
		asm sti; asm hlt; asm cli;
	}
}

//
Tdos_com_port::
t_is_rx
	REF_namespace(NprA)
	Tdos_com_port::
	check_rx(
		){

	//   rx  UART 
	switch( dug[dos_com_idx].dos_uart.s_is_rx.msg ){
		default:
			// 
			err(ERR_BADRES, "unknown s_is_rx.msg", "check_rx"); 
			//dummy return
			return r_NO_RX;
		
		case Tis_rx::NO_RX: 
			// 
			return r_NO_RX;
		
		case Tis_rx::IS_RX_BUF_OVER:
			//    
			// !is_drop_RX_BUF_OVER   
			if(!dug[dos_com_idx].pra_conf.is_drop_RX_BUF_OVER) err(ERR_COMXT, "PE_RX_BUF_OVER"); 
			//   IS_RX
			break;
		
		case Tis_rx::IS_RX:
			//  IS_RX
			break;
	}

	//  IS_RX
	//  rx  UART 
	switch( dug[dos_com_idx].dos_uart.rx.msg ){
		case Trx::RX_DATA:
			//
			//  RX_DATA
			return r_RX_DATA;

		case Trx::RX_DLE:
			//  DLE
			//  RX_SKIP
			return r_RX_SKIP;

		case Trx::RX_SYN:
			//  SYN
			//  RX_SYN
			return r_RX_SYN;

		case Trx::RX_DLE_UNK:
			// DLE  rx 
			// !is_bypass_RX_DLE_UNK   
			if(!dug[dos_com_idx].pra_conf.is_bypass_RX_DLE_UNK) err(ERR_COMXT, "PE_RX_DLE_UNK"); 
			//   RX_DATA
			return r_RX_DATA;
			
		case Trx::RX_LINE:
			//   RS232   rx 
			// !is_bypass_RX_LINE   
			if(!dug[dos_com_idx].pra_conf.is_bypass_RX_LINE) err(ERR_COMXT, "PE_RX_LINE"); 
			//   RX_DATA
			return r_RX_DATA;

		case Trx::RX_UART:
			//  UART,  
			err(ERR_COMXT, "PE_UART"); 
			//dummy return
			return r_NO_RX;

		//      
		case Trx::RX_HANDLER:
			//   ,     
			err(ERR_BADPAR, "RX_HANDLER", "check_rx"); 
			//dummy return
			return r_NO_RX;

		case Trx::RX_INIT:
			//   ,     
			err(ERR_BADRES, "RX_INIT", "check_rx"); 
			//dummy return
			return r_NO_RX;

		default:
			// 
			err(ERR_BADRES, "unknown rx.msg", "check_rx"); 
			//dummy return
			return r_NO_RX;
	}
}

//
bool
	REF_namespace(NprA)
	Tdos_com_port::
	pri_main_loop_step(
		){

    //     fi
	    t_prot_ch
			prot_ch= fi_read_tx_ch();

	//  UART
		//        
		//         fi
		if( !tx_ch(prot_ch) )return 1;

	//    
	{
		//   timer_no_reply
		timer_no_reply[dos_com_idx].start();
		
		//    cli
		asm cli;

		//    no_reply
		//    IRQ 
		for(;;){

			// rx   UART
			switch( check_rx() ){
			// 
				case r_NO_RX: 
					// timer_no_reply
					break;
			
			// 
				case r_RX_DATA: {
					// rx   fo_ch
					t_fo_ch
						fo_ch= dug[dos_com_idx].dos_uart.rx.data;
				
					// is_rx
					dug[dos_com_idx].dos_uart.s_is_rx.msg= Tis_rx::NO_RX;
					asm sti; 
				
					// fo_ch  fo
					fo_write_rx_ch( fo_ch );
					return 1;
					}

				case r_RX_SYN: 
					// is_rx
					dug[dos_com_idx].dos_uart.s_is_rx.msg= Tis_rx::NO_RX;
					asm sti; 

					//    SYN/SYN  
					if( prot_ch != PR_SYN )return 1;
						
					//    SYN/SYN  
					return 0;

				case r_RX_SKIP:
				default:
					// is_rx
					dug[dos_com_idx].dos_uart.s_is_rx.msg= Tis_rx::NO_RX;
					asm sti; 
					
					return 1;
			}

			//     
			//     no_reply
			if( timer_no_reply[dos_com_idx].is_timeout ){ 
				asm sti; 
				//        uart
				//   no_reply
				// !is_pri_drop_TX_NO_REPLY   
				++dug[dos_com_idx].pra_stat.tx_no_reply; 
				if(!dug[dos_com_idx].pra_conf.is_pri_drop_TX_NO_REPLY) err(ERR_COMXT, "PE_TX_NO_REPLY"); 
				//dummy
				return 1; 
			}

			//        rx  timeout
			// cli  "sti; hlt; cli"      
			//  IRQ   (   hlt)
			asm sti; asm hlt; asm cli;
		}
	}
}

//
void
	REF_namespace(NprA)
	Tdos_com_port::
	pri_pause_step(
		){
	
	// 
	++dug[dos_com_idx].pra_stat.paused;

	//   keep_alive
	timer_keep_alive[dos_com_idx].start();

	//    cli
	asm cli;

	//  keep_alive
	//    IRQ 
	for(;;){

		//     
		//     keep_alive
		if( timer_keep_alive[dos_com_idx].is_timeout ){ 
			asm sti; 
			//    keep_alive.is_timeout
			++dug[dos_com_idx].pra_stat.resumed_by_keep_alive; 
			return; 
		}

		//        rx  timeout
		// cli  "sti; hlt; cli"      
		//  IRQ   (   hlt)
		asm sti; asm hlt; asm cli;
	}
}

//
void
	REF_namespace(NprA)
	Tdos_com_port::
	sec_main_loop_step(
		){

    // "   fi  prot_ch"    
    //    ,       
    //       Tdos_com_port (. )
    t_prot_ch
		prot_ch;

	// rx      
	{
		//    cli
		asm cli;

		//  rx   
		//    IRQ 
		for(;;){

			bool
				//    rx 
				is_break= 1;

			// rx   UART
			switch( check_rx() ){
			// rx 
				case r_NO_RX: 
					// 
					is_break= 0;
					// ctrl+break  
					break;
			
			// rx 
				case r_RX_DATA: {
					// rx   fo_ch
					t_fo_ch
						fo_ch= dug[dos_com_idx].dos_uart.rx.data;
				
					// is_rx
					dug[dos_com_idx].dos_uart.s_is_rx.msg= Tis_rx::NO_RX;
					asm sti; 
				
					// fo_ch  fo
					fo_write_rx_ch( fo_ch );
					break;
					}

				case r_RX_SYN: 
				case r_RX_SKIP:
				default:
					// is_rx
					dug[dos_com_idx].dos_uart.s_is_rx.msg= Tis_rx::NO_RX;
					asm sti; 
					
					break;
			}

			//    rx    
			//   break   
			if(is_break)break;

			//      
			//   ctrl+break  
			if( kbhit() ){
				asm sti; 
				//  ctrl+break  
				//dummy
				return;
			}

			//        rx
			// cli  "sti; hlt; cli"      
			//  IRQ   (   hlt)
			asm sti; asm hlt; asm cli;
		}
	}

    //   fi  prot_ch
    {
    // "   fi"        
    //      
	//	  :
	//		 tx   SYN  
	//		  /      N
	//			pri:  tx ,  ,  ,  ,  rx   
	//			sec:  ,  ,  tx   ,  rx   
	//		      

		prot_ch= fi_read_tx_ch();
	}

	//  prot_ch    UART
	{
		//       , 
		//         fi
		if( !tx_ch(prot_ch) )return;

		//  ,     
		return;
	}
}
