#ifndef PRA_DOS_H 
#define PRA_DOS_H 
//          

//namespace NprA{
BEGIN_namespace(NprA)

//
//   
class Tapp{
public:
	//       COM XT 
	//  0  EOF (   "  ")
	// DOS /    (     ) 
	//  
	//    ,    PR_SYN
	//    ,    
	FILE
		*fi,
		*fo;
	
	//            
	//    

public:
		Tapp(): fi(0), fo(0) {}
};

//
//COM XT           
class Tdos_com_port {
public:
	//     dos_uart
	typedef 
		Tdos_uart_is_rx
		Tis_rx;

	typedef 
		Tdos_uart_data_rx
		Trx;

public:
	//idx  COM XT     [DOS_COM_PORTS]
	//  idx  Tdos_uart   COM XT     [DOS_COM_PORTS]
	//      COM  in BIOS DATA area
	//    0   DOS_COM_PORTS
	ureg8
		dos_com_idx;

	//         
	inline
	void
		set_dos_com_idx(ureg8 const ci){ dos_com_idx= (ci < DOS_COM_PORTS)? ci: (err(ERR_BOUND,"dos_com_idx","set_dos_com_idx"), 0); } 

public:
	//   
	Tapp
		app;

protected:
	//tx DLE
	//    get_tx_ch()
	//  is_tx_DLE  tx_DLE_data   
	// FIFO     
	
	//       tx 
	//     DLE
	bool
		is_tx_DLE;
	
	//  DLE   tx 
	//     is_tx_DLE
	t_prot_ch
		tx_DLE_data;

	// DLE       
	//   , 
	//   fi_ch   is_tx_DLE 
	//   PR_DLE,  is_tx_DLE   fi_ch  tx_DLE_data
	//   fi_read_tx_ch
	t_prot_ch
		tx_DLE(t_fi_ch const fi_ch);

public:
	//     
	// raw    tx
	//  is_tx_DLE (..  FIFO    DLE)
	//   is_tx_DLE   tx_DLE_data
	//   EOF   PR_SYN
	//      
	//   tx_DLE 
	//        DLE
	//   PR_DLE   is_tx_DLE, tx_DLE_data
	//   is_tx_DLE     
	t_prot_ch
		fi_read_tx_ch();

	//    
	//   rx 
	//   EOF    
	void
		fo_write_rx_ch(t_fo_ch const fo_ch);

public:
	//  UART   
	//   DLE 
	//   
	//       conf
	//     stat
	//    
	//    tx_line
	//     conf
	//  1   
	//  0      
	//      conf   
	//   *main_loop_step
	bool
		tx_ch(t_prot_ch const prot_ch);

protected:
	//   r_*   IRQ rx
	enum t_is_rx{
		//  IRQ rx 
		//    no_reply
		r_NO_RX= 0,
		// Trx    fo_ch    
		r_RX_DATA,
		//  SYN        
		//   
		r_RX_SYN,
		//   SYN        
		//    
		//(   r_RX_SKIP   default)
		r_RX_SKIP
	};
		
	//   rx  UART 
	//      conf       
	//    rx  r_*  enum t_is_rx
	//        
	t_is_rx
		check_rx();

public:
	//     
	//        .. 
	// 0      ( SYN/SYN )
	bool
		pri_main_loop_step();

	//  ( SYN/SYN )  
	//  
	//	    ,        fi
	//	    keep_alive 
	//	-    fi    fi     wakeup  
	//	-    fi      fi      
	void
		pri_pause_step();

	// pri_main_loop  
	#if 0
	for(;;){
		//     SYN/SYN
		if( !pri_main_loop_step() )pri_pause_step();
		
		//  
		char
			outbuf80[162]; 
		pra_stat.pri_sprint80(outbuf80);
		fprintf(stderr,"\r%s",outbuf80);

		// ctrl+break  
		if(kbhit())break;
	}
	#endif

public:
	//     
	//        .. 
	void
		sec_main_loop_step();

	// sec_main_loop
	#if 0
	for(;;){
		//  
		sec_main_loop_step();
		
		//  
		char
			outbuf80[162];
		pra_stat.sec_sprint80(outbuf80);
		fprintf(stderr,"\r%s",outbuf80);
		
		// ctrl+break  
		if(kbhit())break;
	}
	#endif

public:
	//   
	//       
	//	uart_num      (e   dos_uart[uart_num].reset)
	void
		reset();

public:
		Tdos_com_port( 
			):
			dos_com_idx(0),
			//dos_uart[uart_num].reset   
			is_tx_DLE(0)
			{

		set_dos_com_idx(0);
	}

		Tdos_com_port( 
			ureg8 const ci,
			ctor_explicit
			):
			dos_com_idx(0),
			//dos_uart[uart_num].reset   
			is_tx_DLE(0)
			{

		set_dos_com_idx(ci);
	}

};

//  dos COM  ( dug[DOS_COM_PORTS])
//  dos_com_port
extern
Tdos_com_port
	dos_com_port[DOS_COM_PORTS];

//    main      Tdos_com_port
//	 uart_num    DOS_COM_PORTS
//	atexit  
void
	init_dos_com_port();

//C  DOS   uart
class Tdos_uart_conf{
public:
	ureg8
		//  COM XT   DOS
		irq_num;

public:
		Tdos_uart_conf(
			):
			irq_num(Tdos_uart::IRQ_DEF)
			{
	}
};

//  dos COM  ( dug[DOS_COM_PORTS])
//     DOS  uart
extern
Tdos_uart_conf
	dos_uart_conf[DOS_COM_PORTS];

//
// INI     TprA_conf   
//(  "pra_dos.ini"   )
extern
char const
	*const
	pra_conf_ini_fname;

// INI   DOS
//	  " [ COM%1hu ]" 
//	       
//		irq_num = val; //irq number  reinit
//	     TprA_conf "{ ... }"

//  TprA_conf  INI  
//   DOS_COM_PORTS    
// 0  
bool
	read_pra_conf();

//namespace NprA
END_namespace(NprA)
#endif