#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <dos.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"

#include "src/dos/pra_dt.h"
USING_namespace(NprA)

//namespace{
BEGIN_namespace_a

//
//   Tdec_timer  
//inline
static
void
	do_dec_timer(
		Tdec_timer& timer
		){

	// 
	register 
	ureg16
		tmp= timer.dec_counter;

	// 
	if( tmp == static_cast<ureg16>(PR_TIMER_INF) )return;

	// 
	if(!tmp)return;
	
	//     
	--tmp; 
	timer.dec_counter= tmp; 

	//    0    is_timeout
	if(!tmp)timer.is_timeout= 1; 
}	

//namespace
//}
END_namespace_a 		

//
void
	//interrupt
	REF_namespace(NprA)
	Tdos_timer::
	IRQ_handler_body(
		){

	// cli ( IRQ timer      cli) 
	asm cli;

	//   IRQ timer    (!is_init)
	//       (!is_prev_irq_handler)
	if( !dos_irq.is_init || !dos_irq.is_prev_irq_handler ){
		
		// EOI   ISR 
		//     ISR,      IRQ_handler
		//  PIC       
		//        IRQ_handler
		asm{
			mov   al, 0x20
			out   0x20, al
		}

		//  
		//      uart
		{
		Tdos_uart_group
			*p= &dug[0];

		for(uint i= 0; i < DOS_COM_PORTS; ++i, ++p){ 

			++p->pra_stat.timer_err;
		}}

		// 
		return;
	}

	//    
	t_IRQ_handler_entry
		prev= 
			reinterpret_cast<t_IRQ_handler_entry>( MK_FP(
				dos_irq.prev_irq_handler_seg,
				dos_irq.prev_irq_handler_ofs
				));
	(*prev)();

	//      
	for(uint i= 0; i < DOS_COM_PORTS; ++i){
		
		do_dec_timer( timer_no_reply[i] );
		do_dec_timer( timer_keep_alive[i] );
		do_dec_timer( timer_tx_line[i] );
	}	

	// 
	return;
}
