#ifndef PRA_DT_H
#define PRA_DT_H
// IRQ timer  Tdec_timer  

//namespace NprA{
BEGIN_namespace(NprA)

//     
//  dos COM 
//	      ( uart)
extern
Tdec_timer
	timer_no_reply[DOS_COM_PORTS],
	timer_keep_alive[DOS_COM_PORTS],
	timer_tx_line[DOS_COM_PORTS];

//
//  IRQ     dec_timer  COM  
class Tdos_timer{
protected:
	//       IRQ_handler_body
	Tdos_irq
		dos_irq;
		
public:
	//IRQ timer number (  )
	enum{ TIMER_IRQ= 0x08 };

	//  IRQ  timer
	//   interrupt,      dos_timer
	//  PIC 8259  IRQ_handler_body  Tdos_irq::IRQ_handler_entry
	//	 (poll)  IRQ_handler_body    Tdos_irq::IRQ_handler_entry 
	//	   IF  
	//public   IRQ_handler_body  -  IRQ_handler_entry
	void
		IRQ_handler_body();

public:
	//  Tdos_irq     
	//..  Tdos_irq::       CPU
	//	        Tdos_irq::

	protected:
	// save_irq_handler    
	void
		save_irq_handler(){ dos_irq.save_irq_handler(); }

	public:
	//public   set_irq_handler  - init_dos_timer
	void
		set_irq_handler(){ dos_irq.set_irq_handler(); }

	public:
	//public   restore_irq_handler  - atexit_dos_timer
	void
		restore_irq_handler(){ dos_irq.restore_irq_handler(); }

public:
	//dos_irq.IRQ_handler_entry    main   init_dos_timer()
	//      public   dos_irq.IRQ_handler_entry - init_dos_timer
	inline
	void
		set_IRQ_handler_entry(t_IRQ_handler_entry const entry){ dos_irq.IRQ_handler_entry= entry; }

	//
		Tdos_timer(): 
			//  dos_irq  save_irq_handler()
			dos_irq(TIMER_IRQ, 0, 0)
			{ 
	}

		Tdos_timer(
			t_IRQ_handler_entry const entry,
			ctor_explicit
			): 
			//  dos_irq  save_irq_handler()
			dos_irq(TIMER_IRQ, entry, 0)
			{ 
	}

private:
	//    
		Tdos_timer(Tdos_timer const&);
	Tdos_timer& operator=(Tdos_timer const&);
};

//  Tdos_timer
extern
Tdos_timer
	dos_timer;

//    main      Tdos_timer
//	 Tdec_timer::init_value
//	  IRQ timer  Tdec_timer
//	 atexit  atexit_dos_timer() 
void
	init_dos_timer();

//atexit  
//	       
//	   IRQ timer 
void
	atexit_dos_timer();

//namespace NprA
END_namespace(NprA)
#endif
