#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"

#include "src/dos/pra_du.h"
USING_namespace(NprA)

//
void
	REF_namespace(NprA)
	Tdos_uart::
	IRQ_handler_body(
		){

	// cli ( IRQ rx      cli) 
	asm cli;

	//
	//   IRQ rx      !is_init
	if(!dos_irq.is_init){

		//   IS_RX
		set_is_rx();

		//         UART
		rx.msg= Trx::RX_HANDLER;
		
		//  
		++dug[dos_com_idx].pra_stat.com_err;

		// EOI   ISR 
		//     ISR,      IRQ_handler
		//  PIC       
		//        IRQ_handler
		asm{
			mov   al, 0x20
			out   0x20, al
		}

		//  
		return;

		//PIC   
		//     UART   RX_HANDLER
		//  (poll)    IRQ_handler_entry 
		//  Tdos_uart    is_init
	}

	//
	//   IRQ rx
	ureg16
		rx_port= base_port + 0,
		ier_port= base_port + 1,
		//iir_port= base_port + 2,
		lsr_port= base_port + 5
		//msr_port= base_port + 6
		;

	ureg8
		tmp8,

		rx_val,
		//iir_val,
		lsr_val
		;

	//  {LSR+RHR}    IRQ rx
	struct t_rx_pair{
		ureg8
			// RHR UART
			rx,
			//( 4-2)  LSL UART
			lsl
			;

		bool
			//   rx    UART     
			//    3   2  UART (  rx,   lsl)
			is_rx_exist,

			//   rx   PE_RX_BUF_OVER
			//    3   2  UART (  rx,   lsl)
			//	     rx  UART (PE_RX_BUF_OVER)
			//	      1  LSL
			//	 ""  lsl   ""  
			//
			//	     rx (  PE_RX_BUF_OVER_2)
			//	       (  rx)
			is_lsl_over
			;
	}
		//      "    UART"
		rx_pair= { 0, 0, 0, 0 }
		;

	bool
	    //     IRQ  PIC     EOI
	    is_EOI= 1
	    ;

	//     IRQ  PIC    EOI
	{
	asm{
		// ISR
		mov   al, 0x0B
		out   0x20, al
		in    al, 0x20
		mov   byte ptr tmp8, al
	}
	
	// ISR     IRQ  UART    PIC  EOI 
	//        IRQ   UART 
	if( !(tmp8 & IMR_dis) )is_EOI= 0;
	}

	//   IRQ  UART      UART 
	//        UART  
	//	   spurious   IRQ  UART
	//	  IRR PIC 8259   IRQ      
	asm{
		mov   dx, word ptr ier_port
		mov   al, 0x00
		out   dx, al
	}

	//   rx    UART  LSR
	//     
	//	 rx       LSR (      IIR)
	//	   race condition   spurious   IRQ  UART
	//	       POLL  tx  
	for(;;){

		//   LSR    
		//     IRQ rx  {rx_LSR, rx_RHR} 
		//(    rx FIFO  16550) 
		//     0 rx_LSR (  rx ) 
		//         IIR rx  (IIR  2  IIR  3+2) 
		//
		//     {rx_LSR, rx_RHR}       LSR
		//												 0 LSR UART (lsr_val & 0x01U)		 4-1 LSR UART (lsr_val & 0x1EU)
		//           					==0  							==0  
		//  2 								!=0	 							==0  
		//  3 +  2					!=0	 							!=0  
		//   3   2 	==0  							!=0  
		//	      RX_UART
		//	    rx_RHR     0 
		//	  LSR UART     (lsr_val & 0x1CU)==0,   rx_LSR    FE ( 3)
		
		// LSR
		asm{
			mov   dx, word ptr lsr_port
			in    al, dx
			mov   byte ptr lsr_val, al
		}

		//IIR  1 
		//     IRQ  tx  
		//    tx     POLL
		{
			//tx  LSR (lsr_val & 0x60U)
		}
		
		//  rx  LSR (lsr_val & 0x1FU)
		lsr_val &= 0x1FU;

		// tx  LSR (    0)
		//     tx     POLL
		//  LSR      (rx  tx)
		if( cach_rx_line ){
			// lsr_val  rx  ( 4-1)  
			//    rx  ( 4-1)  tx  (   tx )
			if( !(lsr_val & 0x1EU) ){ lsr_val = (cach_rx_line & 0x1EU); }

			//   LSR     rx 
			//     rx   (   tx )

			// tx  (  )
			cach_rx_line= 0;
		}

		//switch rx  IIR
		//  rx ,     rx_pair
		if(!lsr_val)break;

		//  rx: IIR  3 
		if( lsr_val & 0x1EU ){

			//   rx  ( 1)  UART (IS_RX_BUF_OVER) 
			//       rx   rx     RHR 
			if(lsr_val & 0x02U){ 

				//  PE_RX_BUF_OVER
				// PE_RX_BUF_OVER  rx_pair
				//	    is_lsl_over  is_lsl_over 
				rx_pair.is_lsl_over= 1;

				//IS_RX_BUF_OVER     
				if(s_is_rx.msg != Tis_rx::IS_RX_BUF_OVER){
				
					//   IS_RX_BUF_OVER
					s_is_rx.msg= Tis_rx::IS_RX_BUF_OVER;

					//        
					//     UART (PE_RX_BUF_OVER)
					++dug[dos_com_idx].pra_stat.rx_err_buf_over;
				}

				//RX_INIT  set_is_rx
				//  RX_DLE  ,       (RX_INIT)
				//rx.msg= Trx::RX_INIT;
			}

			//  rx_pair   rx  ( 4-2) 
			rx_pair.lsl= (lsr_val & 0x1CU);
		}

		//  rx: IIR  2 ( IIR  3 + IIR  2)  
		if( lsr_val & 0x01U ){

			//  race condition (     )
			//        IRQ  UART 
			//    IRQ  LSR   RX
			//UART    rx  
			//	       overflow, ..   IIR  3
			//    LSR     (!lsr_val)
			asm{
				mov   dx, word ptr rx_port
				in    al, dx
				mov   byte ptr rx_val, al
			}

			//         rx  
			//    LSR            LSR UART

			//    DLE  rx   Trx

			// rx   rx_pair 
			rx_pair.rx= rx_val;

			//
			//    race condition (     )
			//        IRQ  UART 
			//	    IRQ  RX   
			//	  ()    LSR   
			//UART    rx  
			//	      rx_pair  (IS_RX_BUF_OVER_2), 
			//	 UART    , ..   IIR  2
			//    rx_pair.is_rx 
			
			//   rx_pair     
			//    
			if( !rx_pair.is_rx_exist ) rx_pair.is_rx_exist= 1;
			
			//   IS_RX_BUF_OVER
			//      IRQ rx       s_is_rx
			else {
				//  PE_RX_BUF_OVER_2
				//  PE_RX_BUF_OVER_2  rx_pair ( is_lsl_over  redundant 
				//   PE_RX_BUF_OVER_2    is_rx_exist)

				//IS_RX_BUF_OVER     
				if(s_is_rx.msg != Tis_rx::IS_RX_BUF_OVER){
				
					//   IS_RX_BUF_OVER
					s_is_rx.msg= Tis_rx::IS_RX_BUF_OVER;

					//        
					//      IRQ rx (PE_RX_BUF_OVER_2)
					++dug[dos_com_idx].pra_stat.rx_err_buf_over_2;
				}

				//RX_INIT  set_is_rx
				//  RX_DLE  ,       (RX_INIT)
				//rx.msg= Trx::RX_INIT;
			}
		}

		//   LSR   (!lsr_val)

		#ifdef IS_UART_FIFO_MODE
		//  16550 
		//   (rx_pair.is_rx_exist)      LSR
		//..     FIFO    
		{
			//        rx_pair
			if(rx_pair.is_rx_exist)break;
		}
		#endif
	}

	//     rx_pair     LSR
	//  
	if( !rx_pair.is_rx_exist ){
		
		//        UART
		//          RX_UART
		if( rx_pair.lsl || rx_pair.is_lsl_over ){

			//   IS_RX 
			set_is_rx();

			//  UART
			rx.msg= Trx::RX_UART;

			//  
			++dug[dos_com_idx].pra_stat.UART_err;
		}
		
		//      
		//    IIR  2  IIR  3
		else {
		    //   IRQ rx  ,  rx    (RX_NO)
		    // IS_RX  
		}
	}
	//  
	else{ 
		
		//     (  UART  )
		if( rx_pair.lsl ){
			
			//   IS_RX
			set_is_rx();

			//      
			rx.msg= Trx::RX_LINE;
			// rx.error  
			rx.error= rx_pair.lsl;
			// rx.data  , rx_DLE      
			rx.data= rx_pair.rx;

			//  
			++dug[dos_com_idx].pra_stat.rx_err_line;
		}
		
		//     (  UART  )
		else{
			
			//   IS_RX
			set_is_rx();

			//   rx     rx 
			//(    DLE  RX_DLE_UNK)
			//	     rx_DLE 
			//	   rx.msg  rx.data    rx
			rx_DLE(rx_pair.rx);
		}
	}

	//IIR  0
	//     IRQ  rx    RS232 (DSR/CTS/DCD/RI)
	//  rx      UART  MSR
	//        
	{
	}

	//
	//     UART 
	//	   UART     IRQ     IRR PIC 
	//	         
	//	    spurious   IRQ  UART,    IRQ   
	//	  IRQ    LSL    IRQ
	asm{
		mov   dx, word ptr ier_port
		mov   al, UART_IER_VAL
		out   dx, al
	}

	// EOI  
	if(is_EOI){
		
		tmp8= EOI_cmd;
		asm{
			mov   al, byte ptr tmp8
			out   0x20, al
		}
	}

	// 
	return;
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	set_is_rx(
			){ 
	// tmp     cli    set_is_rx()
	register unsigned
		const tmp= s_is_rx.msg; 
		
	//  PE_RX_BUF_OVER_2
	if(tmp == Tis_rx::NO_RX){ 

		//   IS_RX
		s_is_rx.msg= Tis_rx::IS_RX; 

	//  PE_RX_BUF_OVER_2
	}else{
		//IS_RX_BUF_OVER     
		if(tmp == Tis_rx::IS_RX){ 
			
			//   IS_RX_BUF_OVER
			s_is_rx.msg= Tis_rx::IS_RX_BUF_OVER; 

			//        
			//      IRQ rx
			++dug[dos_com_idx].pra_stat.rx_err_buf_over_2;
		}

		//     IS_RX_BUF_OVER
		// set_is_rx()          Trx
		//       Trx     
		//..     IS_RX_BUF_OVER (    )

		//  RX_DLE  ,       (RX_INIT)
		rx.msg= Trx::RX_INIT;
	}
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	rx_DLE(
		t_prot_ch const prot_ch
		){

	//prot_ch      DLE 
	if( rx.msg == Trx::RX_DLE ){

		switch( prot_ch ){
		
		//  DLE  
		//    
		default:
			rx.data= prot_ch;

			//  DLE 
			rx.msg= Trx::RX_DLE_UNK; 

			++dug[dos_com_idx].pra_stat.rx_err_DLE;
			return;

		//  DLE  
		//  
		case PR_DLE_DLE: rx.data= PR_DLE; break;
		case PR_DLE_SYN: rx.data= PR_SYN; break;
		}

		//  DLE  
		rx.msg= Trx::RX_DATA; 
		
		++dug[dos_com_idx].pra_stat.rx; 
		return;
		
	//prot_ch   
	}else{

		switch( prot_ch ){
		//prot_ch   
		case PR_DLE: rx.msg= Trx::RX_DLE; ++dug[dos_com_idx].pra_stat.rx_DLE; break;
		case PR_SYN: rx.msg= Trx::RX_SYN; ++dug[dos_com_idx].pra_stat.rx_SYN; break;

		//prot_ch   
		default:
			rx.msg= Trx::RX_DATA; 
			rx.data= prot_ch;

			++dug[dos_com_idx].pra_stat.rx;
		}
	}
}

//
bool
	REF_namespace(NprA)
	Tdos_uart::
	tx_ch(
		t_prot_ch const prot_ch,
		bool const is_ei 
		){
	
	ureg16
		tx_port= base_port + 0,
		lsr_port= base_port + 5;
	
	ureg8
		lsr_data;

	//  tx  UART
	asm{ 
		mov   dx, word ptr lsr_port

		//    UART
		cli
		in    al, dx
		mov   byte ptr lsr_data, al 
	}
	
	//   rx  UART ( 4-1)
	//  LSR  rx          cach_rx_line
	// LSR  0     RHR (    LSR)
	{
	register
	ureg8
		tmp8= (lsr_data & 0x1EU);
		
		//     rx       rx 
		//    cach_rx_line   rx    RHR
		//(      rx  )
		if(tmp8) cach_rx_line= tmp8;
	}

	// tx   UART 
	//   0x20 
	if( !(lsr_data & 0x20) ){
	
		//  sti       tx_ch
		if(is_ei)asm sti;

		// "tx   UART "
		return 0;
	}
	
	//   tx   UART
	asm{ 
		mov   dx, word ptr tx_port 
		mov   al, byte ptr prot_ch
		out   dx, al
	}

	//  sti       tx_ch
	if(is_ei)asm sti;

	//   tx
	switch( prot_ch ){
		case PR_DLE:	++dug[dos_com_idx].pra_stat.tx_DLE; break;
		case PR_SYN:	++dug[dos_com_idx].pra_stat.tx_SYN; break;
		default: 		++dug[dos_com_idx].pra_stat.tx; 
	}

	// "tx "
	return 1; 
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	reset(
		){

	cach_rx_line= 0;
	
	//rx[].reset();
	static_cast<Tis_rx&>(s_is_rx).reset();
	static_cast<Trx&>(rx).reset();
}
