#ifndef PRA_DU_H
#define PRA_DU_H
// dos UART
//   DOS_COM_PORTS     

//     -D   
//      FIFO  16550 ( )
//#define IS_UART_FIFO_MODE

//namespace NprA{
BEGIN_namespace(NprA)

//      IRQ rx
//       IRQ rx  COM XT 
class Tdos_uart_is_rx{
public:
	//    IRQ rx  
	//        IRQ rx 
	//     is_rx_xxx
	enum t_msg{
		//     IRQ rx   
		//  IRQ rx      
		//     
		//       IRQ rx
		NO_RX= 0,

		//     IRQ rx  COM XT  
		//(..       ..)
		//    IRQ rx   Trx
		// IRQ rx   ,   
		//     NO_RX    
		IS_RX,

			// IS_RX_BUF_OVER     rx     Trx
			//       rx    
			//            
			//  IRQ rx   Trx  ,      
			//
			//	  rx        UART   
			//	          
			//	       IS_RX_BUF_OVER 
			//	     IS_RX (      
			//	       )
            //		          Tis_rx
			//		  switch,     s_is_rx.msg != NO_RX) 
			//			if(s_is_rx.msg){   rx  }
			//
			//	         UART   
			//	        (  
			//	    )      
			//	 IS_RX_BUF_OVER 
			//		  IS_RX_BUF_OVER     IS_RX_BUF_OVER  
			//		     IS_RX_BUF_OVER ( NO_RX  IS_RX)
			//		..     rx       NO_RX 
			//		        IS_RX_BUF_OVER
			//		..  1 LSR   UART      IS_RX
			//	      IS_RX_BUF_OVER      
			//	          IS_RX_BUF_OVER

		//IS_RX     (PE_RX_BUF_OVER)
		//       rx        rx 
		//            
		//	     UART 
		//		      IRQ rx   
		//		    UART ( UART   IRQ rx)
		//	      IRQ rx
		//		         
		//		   (   IRQ rx  )
		//		   LSR     UART     UART
		//         IS_RX*  
		// IRQ rx   ,   
		//     NO_RX    
		IS_RX_BUF_OVER
	};

	//    IRQ rx
	// IRQ rx     IS_RX_*    IRQ rx
	//       NO_RX (    IRQ rx)
	t_msg
		msg;

public:
	//   
	//       
	void
		reset(){ msg= NO_RX; }

		Tdos_uart_is_rx(): msg(NO_RX) {}
};

//         IRQ rx
//       IRQ rx  COM XT 
//    DLE   
class Tdos_uart_data_rx{
public:
	//    IRQ rx  
	//      IRQ rx 
	//    UART 
	//       is_rx
	//        IRQ rx 
	//      (DATA, DLE, SYN  ..)
	enum t_msg{

		// IRQ rx      
		//     data
		// error   
		RX_DATA= 0,

		// IRQ rx   DLE
		//  rx        DLE
		//	        ( RX_ERROR)
		//	   (IS_RX_BUF_OVER_*),   DLE  
		//	       (     DLE)
		// error   
		//   
		RX_DLE,
		
		// IRQ rx   SYN 
		// error   
		//   
		RX_SYN,

		// IRQ rx     DLE  (PE_RX_DLE_UNK)
		//	       DLE
		//     data       ( DLE )
		// error   
		//    
		//	     rx    DLE 
		//	   RX_DATA,     PE_RX_DLE_UNK
		//	        
		//	   rx       
		//	   SYN,     PE_RX_DLE_UNK
		RX_DLE_UNK,

		// IRQ rx       (PE_RX_LINE)
		//	  ( PE_RX_BUF_OVER)   ( Tis_rx)
		//	       rx ,     
		//	         
		//     data
		//	      UART  ,   data   0
		//  UART    error
		//	     UART  ,   error   0
		//   
		//	     rx     
		//	   SYN,     PE_RX_LINE
		//	   rx           
		//	     
		RX_LINE,

		//  BREAK   RS232
		//UART   BREAK  "  0 +  FrameError +  BREAK"
		//      RS232
		//	  COM XT    BREAK   RS232
		//	    " rx     "
		//	..  RX_ERROR
		//
		//	    RS232  COM XT   
		//	   BREAK  

			//      IRQ rx  UART
			//         
			//	         error
			//	        
			//
			//       rx  
			//       
			//(     )

		// IRQ rx    UART (PE_UART)
		//  IRQ_handler     
		//	 UART     IRQ rx
		//	  rx   
		//     UART   
		//   ,    Tdos_uart::reinit
		//
		//     
		// error   
		//   
		RX_UART= 0x10U,

		// IRQ rx     !is_init
		//..  {port, irq}        ISR  UART 
		//	 UART     IRQ rx
		//	  rx   
		//  ,     is_init ( Tdos_uart::reinit) 
		//    IRQ rx ( Tdos_uart::IRQ_handler_entry)    UART
		//
		//     
		// error   
		//   
		RX_HANDLER,

		//        reset 
		//(     RX_DLE)
		//  IRQ rx  IS_RX_*   RX_INIT    
		//
		//     
		// error   
		//   
		RX_INIT
	};
		
	//    IRQ rx
	// IRQ rx       IRQ rx
	//    
	//       IRQ rx
	//   DLE  
	//      
	t_msg
		msg;

	//   ,  msg    rx     
	//  msg == RX_DATA | RX_DLE_UNK | RX_LINE
	// IRQ rx     
	//      
	//    
	t_fo_ch
		data;

	//     msg == RX_ERROR
	// PE_RX_*    
	// IRQ rx   
	//    
	uint
		error;

public:
	//   
	//       
	void
		reset(){ msg= RX_INIT; }

		Tdos_uart_data_rx(): msg(RX_INIT) {}
};

//
//   dos UART 
//  
class Tdos_uart {
public:
	//    
	typedef 
		Tdos_uart_is_rx
		Tis_rx;

	typedef 
		Tdos_uart_data_rx
		Trx;

public:
	//   /    ( , ,   )

	//UART  baud (  /)
	//( DOS "mode"      19200)
	//    B_115200
	//  COM XT     RS232  
	enum t_baud{
		// 0       DOS "mode"
		B_DEF= 0,
		//115200,   UART == 1
		B_115200,
		//57600,   UART == 2
		B_57600,
		//38400,   UART == 3
		B_38400
	};

	//   UART: parity data stop 
	//   DOS "mode"
	//    "parity=n data=8 stop=1"
	//  COM XT    odd   "parity=o data=8 stop=1"
	//(odd       1,      0)

protected:
	//  IRQ  rx  rx     (LSR) UART
	//	    rx     UART  IRQ  rx 
	//       tx    poll 
	//	   tx     UART   LSR
	// POLL tx_ch    
	// IRQ rx   
	ureg8
		volatile
		cach_rx_line;

public:
	//  (rx)    UART  IRQ rx
	//    volatile  Tis_rx  Trx
	//	       ( , )
	//	     DLE

	//   CLI    
	//   is_rx   Trx
	//    is_rx_buf_over
	//    Trx
	//    is_rx  is_rx_buf_over   Trx
	//   IRQ rx  COM XT 
	//  for(;;){
	//		// if(is_rx)    CLI, 
	//		//    is_rx == 0,     hlt 
	//		//	IRQ rx  COM XT     "if(is_rx)"   "hlt", 
	//		//	  "hlt"        
	//		//	     IRQ    (  )
	//		asm cli; if(is_rx){ is_rx=0; asm sti; break; } 
	//		// "sti+hlt"     , 
	//		//.. sti  IF=1    
	//		asm sti; asm hlt; 
	//	}
	
	//     IRQ rx  COM XT  
	//(        is_rx)
	Tis_rx
		volatile
		s_is_rx;

	//  is_rx 
	//        IRQ rx
	Trx
		volatile
		rx;

public:
	//  IRQ  COM XT 
	//   interrupt,      dos_uart
	//  rx
	//  PIC 8259  IRQ_handler_body  IRQ_handler_entry
	//	 (poll)  IRQ_handler_body    IRQ_handler_entry 
	//	   IF  
	//public   IRQ_handler_body  -    IRQ_handler_entry
	void
		IRQ_handler_body();

protected:
	// rx      Trx
	//  rx
	// rx_DLE     IRQ_handler
	void
		rx_DLE(
			t_prot_ch const prot_ch
			);

	//    is_rx    IS_RX_BUF_OVER_2
	// set_is_rx()          Trx
	//     IRQ_handler
	void
		set_is_rx();
			
public:
	//  (tx)    UART  poll
	// tx     tx_ch
	//	     (      )
	//	   DLE        tx_ch

	//   UART    UART 
	//     UART
	// is_ei==1     tx_ch  
	//  tx_ch     "asm sti"
	// 0       UART (  tx  )
	//  1     tx
	bool
		tx_ch( 
			t_prot_ch const prot_ch,
			bool const is_ei 
			);

public:
	//   
	//         
	void
		reset();

public:
	// UART
	
	// irq number  reinit
	//   {3,4,5,7}
	enum{ IRQ_3= 3, IRQ_4= 4, IRQ_5= 5, IRQ_7= 7 };
	
	//   {2,16,17}
	//	 2      8-15  irq2
	//		  BIOS  irq9  irq2
	//	 16   irq  
	//	 17    irq   com  c_n
	enum{ IRQ_2= 2, IRQ_NO= 16, IRQ_DEF= 17 };
	
	// COM XT   IRQ_DEF
	//     
	//	com1/com3  irq4
	//	com2/com4  irq3

	// UART
	//     port  irq 
	//  IRQ rx 
	// IRQ_handler_entry      
	// dos_com_idx      
	//	        [DOS_COM_PORTS] 
	//	  reinit __  { port  irq }
	//	     reinit
	//		      port,    
	//		"bios_com_idx in BIOS DATA area"  "dos_com_idx   [DOS_COM_PORTS]"
	void
		reinit(
			//dos com port number 
			//   bios_com_idx (com port idx in BIOS DATA area)
			//  1-4
			ureg8 const c_n,

			//irq number
			ureg8 const i_n= IRQ_DEF,
			
			// /
			t_baud const b= B_115200
			);

public:
	//  Tdos_irq    COM 
	//..  Tdos_irq::       CPU

	//      COM   
	// save_irq_handler  
	//	    BIOS   spurious INT
	//		 restore   
	//	   IRQ   IMR PIC  
	//		 restore  IRQ  UART     IMR PIC
	//	  UART  
	//		 restore   IRQ  UART     IER UART
	//		 restore FIFO    FCR UART

	protected:
	//   IRQ rx 
	//	 dos_irq.save_irq_handler()
	//    save_irq_handler   restore_irq_handler
	// reinit         port  irq
	// save_irq_handler    reinit
	//   sti
	void
		save_irq_handler();

	protected:
	//  IRQ rx   (IRQ_handler)
	// UART    rx   IRQ rx
	// new_baud==0    baud   
	//	 dos_irq.set_irq_handler()
	//
	//  set_irq_handler   save_irq_handler
	// reinit         port  irq
	// IRQ_handler_entry      
	// set_irq_handler    reinit
	//   sti
	void
		set_irq_handler(
			ureg16 const new_baud
			);

	public:
	//   IRQ rx 
	//  IRQ  UART   PIC
	//	 dos_irq.restore_irq_handler()
	//        
	//  reinit         port  irq
	//   sti
	//public   restore_irq_handler  - atexit_dos_uart
	void
		restore_irq_handler();

public:
	//  
	//       
	//      

	//dos_irq.is_init      COM  { base_port, irq_num }
	//dos_irq.irq_num    PIC_IRQ_BASE (dos_irq.irq_num      CPU,    IRQ  PIC)
	//dos_irq.IRQ_handler_entry    main   init_dos_uart()
	//public   dos_irq.IRQ_handler_entry  - init_dos_uart
	//public     dos_irq       Tdos_uart
	Tdos_irq
		dos_irq;

	//0  reinit          port  irq  
	//       port  irq 
	//   reinit   
	//  dos_irq.is_init

	//UART base port addr
	ureg16
		base_port;

	//UART IRQ number 
	//    , EOI_cmd  PIC 8259
	// (dos_irq.irq_num - PIC_IRQ_BASE)

	// 8 IRQ  PIC    CPU
	enum { PIC_IRQ_BASE= 0x08U };

	// EOI    UART IRQ number 
	//(   specific EOI)
	ureg8
		EOI_cmd;

	// IMR PIC    UART IRQ number 
	//   UART IRQ   OR
	// UART IRQ    AND    IMR_dis 
	ureg8
		IMR_dis;

	//  IRQ   UART ( IER)
	// 3-0: rx   IRQ, rx error IRQ, tx IRQ, rx IRQ
	enum { UART_IER_VAL= 0x01U };

public:
	//idx  Tdos_uart    [DOS_COM_PORTS]
	//      COM  in BIOS DATA area
	//	 Tdos_uart      (, ,  ..)
	//	Tdos_uart  ,     
	//	  Tdos_uart        [DOS_COM_PORTS]
	//    Tdos_uart
	ureg8
		dos_com_idx;

public:
		~Tdos_uart(){ restore_irq_handler(); }
	
	//
		Tdos_uart(	
			):
			// Tdos_irq  
			dos_irq(),
			dos_com_idx(0)
			{ 
		
		reset(); 
	}

		Tdos_uart(
			t_IRQ_handler_entry const entry,
			ureg8 const dui
			): 
			// Tdos_irq  ,   entry (  entry  !entry)
			dos_irq(entry,0),
			//    dos_com_idx
			dos_com_idx(dui)
			{ 
		
		reset(); 
	}

private:
	//    
		Tdos_uart(Tdos_uart const&);
	Tdos_uart& operator=(Tdos_uart const&);
};

//
//   
//       Tdos_uart
class Tdos_uart_group{
public:
	//    COM XT   
	Tdos_uart
		dos_uart;

	//      
	TprA_conf
		pra_conf;

	//          
	TprA_stat
		pra_stat;
};

//
//    COM  DOS (  Tdos_uart_group)
//     COM  in BIOS DATA area
//	    COM  DOS (DOS_COM_PORTS==2) 
//	      COM  3  4 in BIOS DATA area
//     DOS_COM_PORTS    
//  DOS_COM_PORTS    
//	         
//	 DOS_COM_PORTS      1  DEF_DOS_COM_PORTS_MAX
//	..      dos_uart[DOS_COM_PORTS]
//	     t_IRQ_handler_entry 
//	 Tdos_uart::IRQ_handler_body     Tdos_uart
enum { DEF_DOS_COM_PORTS_MAX= 4 };
enum { DOS_COM_PORTS= 4 };

//  dos COM 
//         
extern
Tdos_uart_group
	dug[DOS_COM_PORTS];

//    main      dos_uart[DOS_COM_PORTS]
//	 IRQ_handler_entry  DOS_COM_PORTS   dos_uart
//	(   1  DEF_DOS_COM_PORTS_MAX  IRQ_handler_entry)
//	 atexit  atexit_dos_uart() 
void
	init_dos_uart();

//atexit  
//	       
//	    dos_uart[DOS_COM_PORTS]  restore_irq_handler
//	(      DOS_COM_PORTS  dos_uart)
void
	atexit_dos_uart();

//namespace NprA
END_namespace(NprA)
#endif