#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <dos.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"

#include "src/dos/pra_du.h"
USING_namespace(NprA)

//
Tdos_uart_group
	REF_namespace(NprA)
	dug[DOS_COM_PORTS];

//**********************
template<int N> class S{ public: 
//  IRQ     Tdos_uart
static void interrupt com_IRQ_handler_entry(){ register Tdos_uart_group *const p= &dug[0]; p[N].dos_uart.IRQ_handler_body(); }

//   switch  init_dos_uart 
static void idu_case(){ 
	dug[N].dos_uart.dos_com_idx= N; 
	dug[N].dos_uart.dos_irq.IRQ_handler_entry= S<N>::com_IRQ_handler_entry; 
	}
};

//
void
	REF_namespace(NprA)
	init_dos_uart(
		){
	//
	register uint
		tmp= DOS_COM_PORTS;

	if( !tmp )return;
	if( tmp > 4 )err(ERR_BOUND, "DOS_COM_PORTS > 4", "init_dos_uart");

	//
	if( atexit(atexit_dos_uart) )err(ERR_BADRES, "atexit(atexit_dos_uart)", "init_dos_uart");

	//    IRQ    Tdos_uart
	// dos_uart_num    Tdos_uart
	for(uint i= 0; i < DOS_COM_PORTS; ++i){ 
		//
		switch(i){
		case 0: S<0>::idu_case(); break;
		case 1: S<1>::idu_case(); break;
		case 2: S<2>::idu_case(); break;
		case 3: S<3>::idu_case(); break;
		}
	}
}

//
void
	REF_namespace(NprA)
	atexit_dos_uart(
		){

	//  IRQ    Tdos_uart
	for(uint i= 0; i < DOS_COM_PORTS; ++i){ dug[i].dos_uart.restore_irq_handler(); }
}

//**********************
void
	REF_namespace(NprA)
	Tdos_uart::
	reinit(
		ureg8 const c_n,
		ureg8 const i_n,
		t_baud const b
		){

	//    ,    
	restore_irq_handler();
	
	//     is_init
	dos_irq.is_init= 0;
		
	//
	ureg16
		//    BIOS (0:400)     COM  
		port_ofs,
		new_baud,
		tmp16;

	ureg8
		//irq_num    IRQ_DEF
		def_irq_num,
		new_irq_num;

//   reinit
	//
	switch(c_n){
	case 1: port_ofs= 0; def_irq_num= 4; break;
	case 2: port_ofs= 2; def_irq_num= 3; break;
	case 3: port_ofs= 4; def_irq_num= 4; break;
	case 4: port_ofs= 6; def_irq_num= 3; break;
	default: err(ERR_BOUND, "COM port number must be [1-4]", "reinit");
	}

	asm{
		push  es
		mov   ax, 0
		mov   es, ax
		mov   bx, 0x400
		add   bx, word ptr port_ofs

		mov   ax, word ptr es:[bx]
		mov   word ptr tmp16, ax
		pop   es
	}
	if(!tmp16)err(ERR_RES_BOUND, "COM port addr in BIOS area can not be 0", "reinit");

	base_port= tmp16;

	//
	switch(i_n){
	case IRQ_DEF: 
		new_irq_num= def_irq_num;
		break;
	case IRQ_2: case IRQ_3: case IRQ_4: case IRQ_5: case IRQ_7: 
		new_irq_num= i_n; 
		break;
	case IRQ_NO:
		//new_irq_num= IRQ_NO; 
		err(ERR_NOT_IMPL, "COM port IRQ_NO", "reinit");
		break;
	default: err(ERR_BOUND, "COM port IRQ number incorrect", "reinit");
	}
	
	//  irq_num   PIC 8259 
	//      CPU,    IRQ  PIC
	dos_irq.irq_num= new_irq_num + PIC_IRQ_BASE;
	
	//  EOI
	// spEOI = 0x60U | (new_irq_num & 7)
	EOI_cmd= 0x20U;
	//  IMR
	IMR_dis= (0x01U << new_irq_num);

	//
	switch(b){
	case B_DEF:		new_baud= 0; break;
	case B_115200:	new_baud= 1; break;
	case B_57600:	new_baud= 2; break;
	case B_38400:	new_baud= 3; break;
	default: err(ERR_BOUND, "COM port baud rate incorrect", "reinit");
	}

	// 
	//     COM  {port, irq} 
	dos_irq.is_init= 1;

	//   IRQ  UART  irq_num 
	save_irq_handler();

	//  IRQ  irq_num   
	// UART    rx   IRQ rx
	set_irq_handler(new_baud);
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	set_irq_handler(
		ureg16 const new_baud
		){

	//
	if(!dos_irq.is_prev_irq_handler)err(ERR_BADPAR, "COM port prev irq_handler was not saved", "Tdos_uart::set_irq_handler");

	if(!dos_irq.is_init)err(ERR_BADPAR, "port,irq not defined", "set_irq_handler");
	if(!dos_irq.IRQ_handler_entry)err(ERR_BADPAR, "irq_handler entry point not defined", "Tdos_uart::set_irq_handler");

	//  IRQ rx  IMR PIC 8259
	//   IRQ
	{
	ureg8
		tmp8= IMR_dis;

	asm{
		cli
		in   al, 0x21
		or   al, byte ptr tmp8
		out  0x21, al
		sti
	}}

	//  IRQ rx    (   IRQ_handler)
	dos_irq.set_irq_handler();

	// UART
	//     UART
	//(,     rx)
	{
	ureg16
		tmp16= base_port;

	asm{
		//UART IER set to IRQ rx
		mov   dx, word ptr tmp16
		inc   dx
		mov   al, UART_IER_VAL
		out   dx, al
	}}

	#ifdef IS_UART_FIFO_MODE
	//  16550 
	//  rx FIFO 
	{
	ureg16
		tmp16= base_port;

	asm{
		mov   dx, word ptr tmp16
		add   dx, 2
		mov   al, 0x07
		out   dx, al
	}}
	#else
	// FIFO ( 8250)
	{
	ureg16
		tmp16= base_port;

	asm{
		mov   dx, word ptr tmp16
		add   dx, 2
		mov   al, 0x00
		out   dx, al
	}}
	#endif

	//      LCR
	//   (new_baud != 0)      baud 
	{
	ureg16
		tmp16= base_port;
	
	if(!new_baud)asm{
		//     LCR
		mov   dx, word ptr tmp16
		add   dx, 3
		
		cli
		in    al, dx
		
		and   al, 0x7F
		out   dx, al
		sti

	}else asm{
		//     LCR
		mov   dx, word ptr tmp16
		add   dx, 3
		
		cli
		in    al, dx
			//  CL  LCR
		mov   cl, al

		or    al, 0x80
		out   dx, al

		//   baud
		sub   dx, 3
		mov   ax, word ptr new_baud
		out   dx, al
		
		//   baud
		inc   dx
		mov   al, ah
		out   dx, al

		//     LCR
		add   dx, 2
			//  LCR  CL 
		mov   al, cl
		
		and   al, 0x7F
		out   dx, al
		sti
	}}

	//    UART 
	{
	ureg16
		tmp16= base_port;
	
	asm{
		//  UART 
		mov   dx, word ptr tmp16
		in    al, dx
		// LSR UART 
		add   dx, 5
		in    al, dx
		// MSR UART 
		inc   dx
		in    al, dx
	}}

	//    
	reset();

	//  MCR.OUT2=1      UART IRQ  COM 
	//   MCR.OUT2     COM         UART 8250
	//(    MCR.OUT2   UART IRQ       ) 
	{
	ureg16
		tmp16= base_port;

	asm{
		mov   dx, word ptr tmp16
		// MCR UART 
		add   dx, 4

		cli
		in    al, dx
		//  3 (OUT2= 1)
		or    al, 0x08
		out   dx, al
		sti
	}}

	//  IRQ  IMR PIC 8259
	//   rx   IRQ rx
	{
	ureg8
		tmp8= ~IMR_dis;

	asm{
		cli
		in    al, 0x21
		and   al, byte ptr tmp8
		out   0x21, al
		sti
	}}
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	save_irq_handler(
		){

	//
	if(dos_irq.is_prev_irq_handler)err(ERR_BADPAR, "COM port irq_handler already saved", "Tdos_uart::save_irq_handler");

	if(!dos_irq.is_init)err(ERR_BADPAR, "port,irq not defined", "Tdos_uart::save_irq_handler");

	//   IRQ rx 
	dos_irq.save_irq_handler();
}

//
void
	REF_namespace(NprA)
	Tdos_uart::
	restore_irq_handler(
		){

	//      IRQ rx   
	if(!dos_irq.is_prev_irq_handler)return;

	if(!dos_irq.is_init)err(ERR_BADPAR, "port,irq not defined", "Tdos_uart::restore_irq_handler");

	//  IRQ rx  IMR PIC 8259
	//   IRQ 
	//     IRQ    
	{
	ureg8
		tmp8= IMR_dis;

	asm{
		cli
		in   al, 0x21
		or   al, byte ptr tmp8
		out  0x21, al
		sti
	}}

	// IRQ  UART
	{
	ureg16
		tmp16= base_port;
	
	asm{
		mov   dx, word ptr tmp16
		inc   dx
		mov   al, 0x00
		out   dx, al
	}}

	// FIFO  UART
	{
	ureg16
		tmp16= base_port;
	
	asm{
		mov   dx, word ptr tmp16
		add   dx, 2
		mov   al, 0x00
		out   dx, al
	}}

	//    IRQ rx
	dos_irq.restore_irq_handler();
}
