//pra_dos_in.cpp:       fi_read_tx_ch
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <conio.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"

#include "src/dos/pra_dos.h"

#include "src/dos/u1/u1_d.h"
USING_namespace(NprA)

//
bool
	REF_namespace(NprA)
	is_INT3_requested= 0,

	REF_namespace(NprA)
	is_CTRL_BREAK_requested= 0;

//
static
int
	//current size of ansi term seq \033[<key>
	tx_esc_sz= 0,
	//ansi term seq \033[<key>
		//    [0]   [2]   : <key>,'[',\033
		//       tx_esc_sz
		//	  tx_esc_sz 
		//	     tx_esc_data[tx_esc_sz] 
	tx_esc_data[3];

//translate extended getch() dos term seq \0<key> 
//into ansi term seq \033[<key>
//       { tx_esc_sz, tx_esc_data }
//  tx_esc_sz==0         tx   
static
void
	dos_2_ansi(
		int const fi_ch
		){
	
	//if(!p_fi_ch)err(ERR_ZPTR, "p_fi_ch", "dos_2_ansi");

	//  - 
	tx_esc_sz= 1;

	switch(fi_ch & 0x00FFU){
		//   - 
		//le
		case 'K':	tx_esc_data[0]= 'D'; break;
		//rt
		case 'M':	tx_esc_data[0]= 'C'; break;
		//up
		case 'H':	tx_esc_data[0]= 'A'; break;
		//dn
		case 'P':	tx_esc_data[0]= 'B'; break;
		//pgup
		case 'I':	tx_esc_data[0]= 'V'; break;
		//pgdn
		case 'Q':	tx_esc_data[0]= 'U'; break;
		//home
		case 'G':	tx_esc_data[0]= 'H'; break;
		//end
		case 'O':	tx_esc_data[0]= 'Y'; break;
		//ins
		case 'R':	tx_esc_data[0]= '@'; break;
		//digital '5'
		case 'L':	tx_esc_data[0]= 'G'; break;

		//ctrl+pgup
		case 0x84U:	tx_esc_data[0]= 'K'; break;
		//ctrl+pgdn
		case 'v':	tx_esc_data[0]= 'J'; break;
		//ctrl+home
		//case 'w':	tx_esc_data[0]= ''; break;
		//ctrl+end
		//case 'u':	tx_esc_data[0]= ''; break;

		//   - 
		//del
		case 'S':	tx_esc_data[0]= ('\177' & 0x00FFU); return;

		//F1 - F10
		case ';':	tx_esc_data[0]= ('\261' & 0x00FFU); return;
		case '<':	tx_esc_data[0]= ('\262' & 0x00FFU); return;
		case '=':	tx_esc_data[0]= ('\263' & 0x00FFU); return;
		case '>':	tx_esc_data[0]= ('\264' & 0x00FFU); return;
		case '?':	tx_esc_data[0]= ('\265' & 0x00FFU); return;
		case '@':	tx_esc_data[0]= ('\266' & 0x00FFU); return;
		case 'A':	tx_esc_data[0]= ('\267' & 0x00FFU); return;
		case 'B':	tx_esc_data[0]= ('\270' & 0x00FFU); return;
		case 'C':	tx_esc_data[0]= ('\271' & 0x00FFU); return;
		case 'D':	tx_esc_data[0]= ('\260' & 0x00FFU); return;
		//alt+1 - alt+0
		case 'x':	tx_esc_data[0]= ('\261' & 0x00FFU); return;
		case 'y':	tx_esc_data[0]= ('\262' & 0x00FFU); return;
		case 'z':	tx_esc_data[0]= ('\263' & 0x00FFU); return;
		case '{':	tx_esc_data[0]= ('\264' & 0x00FFU); return;
		case '|':	tx_esc_data[0]= ('\265' & 0x00FFU); return;
		case '}':	tx_esc_data[0]= ('\266' & 0x00FFU); return;
		case '~':	tx_esc_data[0]= ('\267' & 0x00FFU); return;
		case 0x7FU: tx_esc_data[0]= ('\270' & 0x00FFU); return;
		case 0x80U: tx_esc_data[0]= ('\271' & 0x00FFU); return;
		case 0x81U: tx_esc_data[0]= ('\260' & 0x00FFU); return;
		
		//   
		//Alt+I   DOS INT3
		case 0x17U:	is_INT3_requested= 1; tx_esc_sz= 0; return; 
		//Alt+C   DOS CTRL_BREAK
		case 0x2EU:	is_CTRL_BREAK_requested= 1; tx_esc_sz= 0; return;

		//  
		default: 
			// 
			//tx_esc_sz= 0; return;

			//  -  \033[<key>
			tx_esc_data[0]= (fi_ch & 0x00FFU);
	}

	//  -  \033[<key>
	tx_esc_sz= 3;
	tx_esc_data[1]= '[';
	tx_esc_data[2]= '\033';
}

//
t_prot_ch
	REF_namespace(NprA)
	Tdos_com_port::
	fi_read_tx_ch(
		){

	//   get_tx_ch    
	//    DLE
	if(is_tx_DLE){

		is_tx_DLE= 0;
		return tx_DLE_data;
	} 

	int 
		fi_ch; 

	//        \006<str>\n
	if(tty_replay_sz){
		--tty_replay_sz;
		fi_ch= tty_replay_data[tty_replay_sz];

	//     \033[<key>
	}else if(tx_esc_sz){
		--tx_esc_sz;
		fi_ch= tx_esc_data[tx_esc_sz];
	
	//     tx    
	}else{
		//int fi_ch= app.fi? fgetc(app.fi): EOF;
		//  
		if( !kbhit() )return PR_SYN;
		
		//fi_ch=fgetc(stdin);
		fi_ch= getch(); 

		//  BIOS  "\0"+key 
		//  ANSII esc      
		//  "\033["+key
		if(!fi_ch){
		    
		    dos_2_ansi( getch() );

	    	//  ,     tx   
			if(!tx_esc_sz)return PR_SYN;

			//    \033[<key>
			--tx_esc_sz;
			fi_ch= tx_esc_data[tx_esc_sz];
		}
	}

	//     tx (!= EOF), 
	//    tx_DLE  raw  
	//	   raw  
	//	    is_tx_DLE      tx_DLE_data
	//  PR_SYN
	//return ( EOF != fi_ch )? tx_DLE(fi_ch): PR_SYN;
	return tx_DLE(fi_ch);
}
