//pra_dos_ot.cpp:     termcap   fo_write_rx_ch
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <conio.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"

#include "src/dos/pra_dos.h"

#include "src/dos/u1/u1_d.h"
USING_namespace(NprA)

/*
	        
	  ESC     (  rx_esc_data)
	        rx_esc_data[]     
	  /       
	      termcap 

	      ANSI.SYS     
	      
		       
		      (  ESC   ANSI.SYS)
		     (  ESC   ANSI.SYS) 
	  ANSI.SYS       
*/

//
int
	REF_namespace(NprA)
	tty_replay_sz= 0,

	REF_namespace(NprA)
	tty_replay_data[MAX_TTY_REPLAY_SZ];

	// \ACK (\x06, ^F)   \n 
	//        
	//   define    
	#define tty_replay_name ("\nisnasod\006")

static
int
	//    ESC  \033<str>    
	//      termcap  (tc_sr ) 
	//    ESC       ansi DOS 
	//  termcap   ESC 
	//  ESC      termcap  
	rx_esc_sz= 0,
	// ESC  \033<str>    
	rx_esc_data[3];

/*
  termcap  DOS ANSI.SYS p   
  BIOS     DTA 0:400 (   int 10h AL=0fh)
      ANSI.SYS

	BIOS     DTA 0:400  "video segment"  
		B800  color video card 
		B000  mono video card

	    8025      
		   
		   

	0400:0049	byte 	text mode 03(color card 8025)/07(mono card 8025)
	0400:004a	word 	cols (80 for mode 8025)
	0400:004c	word 	active video page size (in bytes)
	0400:004e	word 	offset to active video page in video segment
	0400:0062	byte 	active video page number (BIOS handle)
*/

static
void
	/* 
	   tc_XX  ( inline)
	    tc_XX 
	
	return
		AX 	active video page segment (video segment)
		BX	active video page offset (video offset)
		CX	cursor LINE pos
    */
	cdecl
	set_ax_bx_cx(
		){

	asm{

	//get video mode
	mov   ah, 0x0F
	int   0x10
	//return BH active video page number

	//get cursor pos in BH video page
	mov   ah, 0x03
	int   0x10
	//return DH cursor LINE pos
	
	mov   ch, 0
	xchg  cl, dh
	//*in CX cursor LINE pos

	mov   ax, 0x0040
	mov   es, ax

	//
	mov   bx, word ptr es:[0x004e]
	//*in BX active video page offset
	
	//check active card mode to select active video page segment
	mov   al, byte ptr es:[0x0049]
	cmp   al, 7
	
	mov   ax, 0xb800
	jne   color_seg
	
	//mono_seg:
	mov   ax, 0xb000

	color_seg:
	//*in AX active video page segment
	}
}

//implements termcap::sr for dos ansi.sys
//        (scroll reverse)
static
void
	tc_sr(
		){

	asm{
	push  ds
	push  es
	//   BC++   linkage  register 
	//push  si
	//push  di

	call  near ptr set_ax_bx_cx

	//  tc_xx    cx

	mov   es, ax
	mov   ds, ax

	//   ,     
	//end of last line 
	mov   di, (80*2)*(25-1)+(160-2)
	add   di, bx
	//end of last line-1 
	mov   si, (80*2)*(25-2)+(160-2)
	add   si, bx
	
	//copy (25-1) lines by words
	mov   cx, (80*2)*(25-1)/2
	
	//DF for reverse direction copy 
	std
	rep movsw

	//by wide-spreaded library convention, we must clear DF after usage
	cld

	//
	pop   es
	pop   ds
	}
}

//implements termcap::al for dos ansi.sys
//      ,      
static
void
	tc_al(
		){

	asm{
	push  ds
	push  es
	//   BC++   linkage  register 
	//push  si
	//push  di

	call  near ptr set_ax_bx_cx

	//   cx    [0-24]
	//   cx     [24]     
	cmp   cx, 24
	jnc   line_out_of_screen

	mov   es, ax
	mov   ds, ax

	//   ,     
	//end of last line 
	mov   di, (80*2)*(25-1)+(160-2)
	add   di, bx
	//end of last line-1 
	mov   si, (80*2)*(25-2)+(160-2)
	add   si, bx
	
	//copy 80*((25-1)-LINE) lines by words
	//mov   cx, (80*2)*(25-1)/2
	neg   cx
	add   cx, (25-1)
	imul  cx, cx, (80*2)/2
	
	//DF for reverse direction copy 
	std
	rep movsw

	//by wide-spreaded library convention, we must clear DF after usage
	cld

	line_out_of_screen:
	//
	pop   es
	pop   ds
	}
}

//the same as \n
#if 0
//implements termcap::sf for dos ansi.sys
//        (scroll forward)
static
void
	tc_sf(
		){

	asm{
	push  ds
	push  es
	//   BC++   linkage  register 
	//push  si
	//push  di

	call  near ptr set_ax_bx_cx

	//  tc_xx    cx

	mov   es, ax
	mov   ds, ax

	//   ,     
	//start of first line 
	mov   di, 0
	add   di, bx
	//start of first line + 1
	mov   si, (80*2)
	add   si, bx
	
	//copy (25-1) lines by words
	mov   cx, (80*2)*(25-1)/2

	//DF     
	cld
	rep movsw

	//
	pop   es
	pop   ds
	}
}
#endif

//implements termcap::dl for dos ansi.sys
//   ,      ,     
static
void
	tc_dl(
		){

	asm{
	push  ds
	push  es
	//   BC++   linkage  register 
	//push  si
	//push  di

	call  near ptr set_ax_bx_cx

	//   cx    [0-24]
	//   cx     [24]     
	cmp   cx, 24
	jnc   line_out_of_screen

	mov   es, ax
	mov   ds, ax

	//   ,     
	//start of first line 
	imul  di, cx, (80*2)
	add   di, bx
	//start of first line + 1
	mov   si, (80*2)
	add   si, di
	
	//copy 80*((25-1)-LINE) lines by words
	//mov   cx, (80*2)*(25-1)/2
	neg   cx
	add   cx, (25-1)
	imul  cx, cx, (80*2)/2

	//DF     
	cld
	rep movsw

	line_out_of_screen:
	//
	pop   es
	pop   ds
	}
}

//  unix     it#4 
#if 0
//implements termcap::it for dos ansi.sys
//expand tab to spaces:  it#4   \t 
static
ushort
	//   [1..it]       \t
	cdecl
	tc_it_4(
		//  it#    == 4
		//uint const it
		){

	ushort
		tmp;

	asm{
	push  ds
	push  es
	//   BC++   linkage  register 
	push  si
	push  di

	//get video mode
	mov   ah, 0x0F
	int   0x10
	//return BH active video page number

	//get cursor pos in BH video page
	mov   ah, 0x03
	int   0x10
	//return DL cursor COLUMN pos

	mov   al, dl
	//it#4
	and   al, 0x03
	neg   al
	add   al, 4
	
	//return "spaces" in AX
	mov   ah, 0
	mov   word ptr tmp, ax

	pop   di
	pop   si
	//
	pop   es
	pop   ds
	//
	}

	return tmp;
}
#endif

//
void
	REF_namespace(NprA)
	Tdos_com_port::
	fo_write_rx_ch(
		t_fo_ch const fo_ch
		){ 

	switch(rx_esc_sz){
		case 0: 
			
			//      Ctrl+E
			//  unix      Ctrl+E
			#if 0
			if(fo_ch == 0x05U){
				//       Ctrl+E
				// ()    Ctrl+E
				if(tty_replay_sz)return;

				//        \0
				//strcpy(tty_replay_data, tty_replay_name);
				{
				int 
					*d= tty_replay_data;

				char const
					*s= tty_replay_name;

				tty_replay_sz= 0;
				for(; *s; ++s, ++d, ++tty_replay_sz){ *d = (*s & 0x00FFU); }
				//  \0
				*d = 0; 
				}

				//       \0
				//tty_replay_sz= strlen(tty_replay_name);
				return;
			}
			#endif

			//   \033 
			if(fo_ch == 27){

				rx_esc_data[0]= fo_ch;
				++rx_esc_sz;
				return;
			}

			//expand tab to spaces:  it#4   \t 
			//  unix     it#4 
			#if 0
			if(fo_ch == 0x09U){
				
				fflush(stdout);
				
				//asm int 3;
				ushort
					//  [1..it]    
					//   \t
					spaces= tc_it_4();
				
				for(ushort i= 0; i<spaces; ++i){ fputc(' ', stdout); }
				//fflush(stdout);
				return;
			}
			#endif

			//  DOS    DOS ANSI
			//..       , 
			//     ANSI     
			#if 0
			//      DOS ANSI
			{
			switch(fo_ch){
				//toggle       
				case 0x10U: //ctrl+P
					//     DOS   
					//   DOS    COM  "mode lpt1=com1"
					//    COM    putty
					return;

				case 0x03U: //ctrl+C
				//     DOS
				case 0x13U: //ctrl+S
				//   DOS
				case 0x1AU: //ctrl+Z
					fputc(0x00U, stdout);
					return;
			}}
			#endif

			//  <fo_ch>
			break;

		case 1:
			//al:^[[L dl:^[[M
			if(fo_ch == '['){
				rx_esc_data[1]= fo_ch;
				++rx_esc_sz;
				return;
			}

			//sr: ^[M
			if(fo_ch == 'M'){
				rx_esc_sz= 0;
				fflush(stdout);
				tc_sr();
				//tc_ho,tc_ce :\033[H
				fputs("\033[K", stdout); 
				//fflush(stdout);
				return;
			}

			//  esc ^[<fo_ch>
			rx_esc_sz= 0;
			fputc(rx_esc_data[0], stdout);
			break;

		case 2:
			//al:^[[L
			if(fo_ch == 'L'){
				rx_esc_sz= 0;
				fflush(stdout);
				tc_al();
				//\r,tc_ce :\r
				fputs("\033[K", stdout); 
				//fflush(stdout);
				return;
			}

			//dl:^[[M
			if(fo_ch == 'M'){
				rx_esc_sz= 0;
				fflush(stdout);
				tc_dl();
				//tc_sav,tc_ll,tc_ce,tc_rst
				fputs("\033[s\033[25;1H\033[K\033[u", stdout); 
				//fflush(stdout);
				return;
			}

			//  esc ^[[<fo_ch>
			rx_esc_sz= 0;
			fputc(rx_esc_data[0], stdout);
			fputc(rx_esc_data[1], stdout);
			break;

		//rx_esc_sz protection
		default:
			//    rx_esc_sz 
			//debug
			fprintf(stderr,"%s: rx_esc_sz protection\n", "error"); exit(1);

			//     
			//   fo_ch   
			rx_esc_sz= 0;
			break;
	}

	//putch(fo_ch); 
	fputc(fo_ch, stdout);
}
