// ANSI     DOS   ANSI.SYS
//  : -p|-s
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>

#include <string.h>
#include <conio.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"
#include "src/dos/pra_dos.h"

#include "src/dos/t1/t1_d.h"
#include "src/dos/u1/u1_d.h"
USING_namespace(NprA)

//
int
	main(
		int argc,
		char *argv[]
		){

	//    
	complete_static_init();
	
	// Ctrl+C (   Alt+C)
	signal(SIGINT, SIGINT_handler);
	//signal(SIGINT, SIG_IGN);

	if( setvbuf(stdin, 0, _IONBF, 0) ){ fprintf(stderr,"%s: setvbuf stdin\n", "error"); exit(1); }
	if( setvbuf(stdout, 0, _IONBF, 0) ){ fprintf(stderr,"%s: setvbuf stdout\n", "error"); exit(1); }
	if( setvbuf(stderr, 0, _IONBF, 0) ){ fprintf(stderr,"%s: setvbuf stderr\n", "error"); exit(1); }

	//     INI 
	read_pra_conf();

	//cmdline settings
	params= parse_cmdline(argc,argv);
	display_cmdline();
	
	// main
	Tdos_com_port
		//alias
		&com_port= dos_com_port[params.com_idx];

	//    
	//set no_reply timeout
	if(params.is_pri){

		//   conf
		dug[params.com_idx].pra_conf.pri_init_timer_no_reply= params.pri_init_timer_no_reply;
		
		// Tdec_timer::init_value 
		timer_no_reply[params.com_idx]= Tdec_timer( params.pri_init_timer_no_reply, 0);
	}
	dug[params.com_idx].dos_uart.reinit(
		// com_idx+1  reinit ( COM    1  4)
		params.com_idx+1, 
		//irq_num     INI  (  COM3/COM4)
		dos_uart_conf[params.com_idx].irq_num
		);
	com_port.reset();

	//********
	//open files
	com_port.app.fi= stdin;
	com_port.app.fo= stdout;

	fprintf(stderr,	
		"press Alt+I to execute DOS INT3 opcode\n"
		"press Ctrl+C to interrupt DOS program\n"
		); 

	//     
	//as primary device
	if(params.is_pri){

		for(;;){
			//     SYN/SYN
			if( !com_port.pri_main_loop_step() )com_port.pri_pause_step();
		
			//  
			#if 0
			{
			char
				outbuf80[161]; 
			dug[params.com_idx].pra_stat.pri_sprint80(outbuf80);
			fprintf(stderr,"\r%s",outbuf80);
			}
			#endif

			// ctrl+break  
			#if 0
			if( kbhit() ){
				if(!getch())getch();
				fprintf(stderr,"\n");
				break;
			}
			if( is_break_pressed ){

				is_break_pressed= 0;
				fprintf(stderr,"\n");
				break;
			}
			#endif
			if( is_CTRL_BREAK_requested ){

				is_CTRL_BREAK_requested= 0;
				fprintf(stderr,"\n");
				break;
			}

			//      DOS  INT3 
			if( is_INT3_requested ){

				is_INT3_requested= 0;
				asm db 0xCC; 
				asm nop;
			}
		}
	
	//as secondary device
	}else{

		for(;;){
			//  
			com_port.sec_main_loop_step();
		
			//  
			#if 0
			{
			char
				outbuf80[161];
			dug[params.com_idx].pra_stat.sec_sprint80(outbuf80);
			fprintf(stderr,"\r%s",outbuf80);
			}
			#endif
		
			// ctrl+break  
			#if 0
			if( kbhit() ){
				if(!getch())getch();
				fprintf(stderr,"\n");
				break;
			}
			if( is_break_pressed ){
				is_break_pressed= 0;
				fprintf(stderr,"\n");
				break;
			}
			#endif
			if( is_CTRL_BREAK_requested ){

				is_CTRL_BREAK_requested= 0;
				fprintf(stderr,"\n");
				break;
			}

			//      DOS  INT3 
			if( is_INT3_requested ){

				is_INT3_requested= 0;
				asm db 0xCC; 
				asm nop;
			}
		}
	}

	//
	fprintf(stderr,"pra: done\n");
	return 0;
}
