//     DOS
//cmdline parser
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>

#include <string.h>
#include <conio.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"
#include "src/dos/pra_dt.h"
#include "src/dos/pra_dos.h"

#include "src/dos/t1/t1_d.h"
USING_namespace(NprA)

//
Tmain_com_port
	REF_namespace(NprA)
	params;

//
void
	REF_namespace(NprA)
	umsg(
		){

	fprintf(stderr,
		"cmdline: [-p|-s [-com_N [-timeout ]]]\n"
		" p|s\t  primary|secondary\n"
		" com_N\t  1-4 (com port number in BIOS data area)\n"
		" timeout  300-60000ms (0 infinitly wait) no_reply timeout (primary only)\n"
		" (default: -p -1 -900)\n"
		"protocol config can be also loaded from INI file:\n '%s'\n",
		pra_conf_ini_fname
		);
}

//
void
	REF_namespace(NprA)
	display_cmdline(
		){

	fprintf(
		stderr, "pra: %s, COM%u",
		(params.is_pri? "primary": "secondary"),
		(params.com_idx+1)
		);	
		
	if(params.is_pri)fprintf(
		stderr, ", timeout: %u ms",
		//mul counter by 55ms per dos timer tick
		(params.pri_init_timer_no_reply*50)
		);

	fprintf(stderr, "\n");
}

//parse cmdline
Tmain_com_port
	REF_namespace(NprA)
	parse_cmdline(
		int argc,
		char *argv[]
		){

	//
	Tmain_com_port
		params;

	params.is_pri= 1;
	params.fi= "con";
	params.fo= "con";

	//
	switch( argc ){
		//pri_init_timer_no_reply
		case 4: {
			unsigned short
				tmp= 0;
			if( sscanf(argv[3], "-%hu", &tmp) != 1 ){ umsg(); err(ERR_BADPAR,"sscanf -timeout","cmdline"); }
			
			if(!tmp) { params.pri_init_timer_no_reply= static_cast<ureg16>(PR_TIMER_INF); }
			else if(tmp < 300){ umsg(); err(ERR_BOUND,"sscanf -timeout < 300","cmdline"); }
			else if(tmp > 60000U){ umsg(); err(ERR_BOUND,"sscanf -timeout > 60000","cmdline"); }
			//div scanned ms by 55ms per dos timer tick
			else params.pri_init_timer_no_reply= static_cast<ureg16>(tmp/50);
			}
			//   case

		//uart_num
		case 3: {
			unsigned
				tmp= 0;
			if( sscanf(argv[2], "-%u", &tmp) != 1 ){ umsg(); err(ERR_BADPAR,"sscanf -com_N","cmdline"); }
			if(!tmp){ umsg(); err(ERR_BOUND,"com_N can not be 0","cmdline"); }
			if(tmp > DOS_COM_PORTS){ umsg(); err(ERR_BOUND,"too big com_N","cmdline"); }
			
			params.com_idx= tmp-1;
			}
			//   case

		//is_pri
		case 2:{
			ureg8
				ch= 0;
			if( sscanf(argv[1], "-%c", &ch) != 1 ){ umsg(); err(ERR_BADPAR,"sscanf -p|-s","cmdline"); }
			switch(ch){
				case 'p': case 'P': params.is_pri= 1; break;
				case 's': case 'S': params.is_pri= 0; break;
				default: umsg(); err(ERR_BADPAR,"expected -p|-s","cmdline"); 
			}}
			//   case

		//default settings
		case 1: 
			break;

		case 0:  umsg(); err(ERR_BADPAR,"can not be zero args","cmdline"); 
		default: umsg(); err(ERR_BADPAR,"too many args","cmdline"); 
	}

	//
	return params;
}	
